.386
;.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include ColorTrackbar.inc
include DisplayText.asm
include Subs.asm
.code

start:

	invoke GetModuleHandle, NULL
	mov		hInstance, eax

    invoke InitCommonControls
	invoke DialogBoxParam, hInstance, IDD_DIALOG1, NULL, addr DlgProc, NULL
	invoke ExitProcess, 0

DlgProc proc hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	.if uMsg==WM_INITDIALOG
		push hWin
		pop hWnd
		invoke InitData
		invoke ScaleTB
		invoke InitControls

		mov hPen, rv(CreatePen, PS_SOLID, 2, 0)
		mov hBG_Brush, rv(CreateSolidBrush, 07F7F7Fh)
		mov hFG_Brush, 0FF7F00h
		jmp _initClr
	.elseif uMsg==WM_COMMAND
		mov eax, wParam
		and eax, 0FFFFh
		.if eax==BTN_TXT_CHO_CLR
			invoke SelectColor, BTN_TXT_CHO_CLR
		.elseif eax==BTN_BGD_CHO_CLR
			invoke SelectColor, BTN_BGD_CHO_CLR
		.elseif eax==BTN_COPY_TXT_CLR
			invoke CopyColor, BTN_COPY_TXT_CLR
		.elseif eax==BTN_COPY_BGD_CLR
			invoke CopyColor, BTN_COPY_BGD_CLR
		
		.elseif eax==DWG_TXT_CTR
			mov style, 1
		.elseif eax==DWG_TXT_LFT
			mov style, 2
		.elseif eax==TXT_OUT_CTR
			mov style, 3
		.elseif eax==TXT_OUT_LFT
			mov style, 4
		.endif
		invoke InvalidateRect, hWnd, addr RT, FALSE
		ret
	.elseif uMsg==WM_LBUTTONDOWN
		mov eax, lParam
		and eax, 0FFFFh
		.if eax > RT.left && eax < RT.right
			mov eax, lParam
			shr eax, 16
			.if eax > RT.top && eax < RT.bottom
		    	invoke ChooseFont,addr CF	; Get font info from FontDialog. cf initializes the font dialog.
				mov hFont, rv(CreateFontIndirect, addr LF)
				invoke InvalidateRect,hWin,NULL,TRUE
			.endif
		.endif
	.elseif uMsg==WM_PAINT
		invoke BeginPaint, hWin, addr PS
			mov hDC, eax
; Draw frame around rectangle.
			invoke SelectObject, hDC, hPen
			invoke MoveToEx, hDC, 13, 251, 0
			invoke LineTo, hDC, 345, 251
			invoke LineTo, hDC, 345, 321
			invoke LineTo, hDC, 14, 321
			invoke LineTo, hDC, 14, 251
			
			invoke FillRect, hDC, addr RT, hBG_Brush
			invoke SelectObject, hDC, hFont

			invoke SetBkMode, hDC, TRANSPARENT
			invoke SetTextColor, hDC, 0
			.if style==1
				invoke DrawTextCenter
			.elseif style==2
				invoke DrawTextLeft
			.elseif style==3
				invoke TextOutCenter
			.elseif style==4
				invoke TextOutLeftCalc
			.endif
		invoke EndPaint, hWin, addr PS
		
	.elseif uMsg==WM_HSCROLL
		mov eax, lParam
		.if eax==hTBR_TXT_RED
			mov txtRed, rv(SendMessage, hTBR_TXT_RED, TBM_GETPOS, 0, 0)
		.elseif eax==hTBR_TXT_GREEN
			mov txtGreen, rv(SendMessage, hTBR_TXT_GREEN, TBM_GETPOS, 0, 0)
		.elseif eax==hTBR_TXT_BLUE
			mov txtBlue, rv(SendMessage, hTBR_TXT_BLUE, TBM_GETPOS, 0, 0)
		.elseif eax==hTBR_BGD_RED
			mov bgdRed, rv(SendMessage, hTBR_BGD_RED, TBM_GETPOS, 0, 0)
		.elseif eax==hTBR_BGD_GREEN
			mov bgdGreen, rv(SendMessage, hTBR_BGD_GREEN, TBM_GETPOS, 0, 0)
		.elseif eax==hTBR_BGD_BLUE
			mov bgdBlue, rv(SendMessage, hTBR_BGD_BLUE, TBM_GETPOS, 0, 0)
		.endif
; Compile RGB for text.
		invoke CompRGB, txtRed, txtGreen, txtBlue
		mov hFG_Brush, eax	; Text color for line3.
		
; Compile RGB for background.
		invoke CompRGB, bgdRed, bgdGreen, bgdBlue
		mov hBG_Brush, rv(CreateSolidBrush, eax)	; Rectangle fill color.
		
		invoke InvalidateRect, hWin, addr RT, FALSE	; Change color of rectangle and text.
_initClr:	; Display color codes.	
		invoke wsprintf, offset szBuffer, SADD("%02X%02X%02X"), txtRed, txtGreen, txtBlue
		invoke SetWindowText, hEDT_TXT_CLR, addr szBuffer
		invoke SetWindowText, hSTC_TXT_RED, sstr$(txtRed)
		invoke SetWindowText, hSTC_TXT_GREEN, sstr$(txtGreen)
		invoke SetWindowText, hSTC_TXT_BLUE, sstr$(txtBlue)
	
		invoke wsprintf, offset szBuffer, SADD("%02X%02X%02X"), bgdRed, bgdGreen, bgdBlue
		invoke SetWindowText, hSTC_BGD_RED, sstr$(bgdRed)
		invoke SetWindowText, hSTC_BGD_GREEN, sstr$(bgdGreen)
		invoke SetWindowText, hSTC_BGD_BLUE, sstr$(bgdBlue)
		invoke SetWindowText, hEDT_BGD_CLR, addr szBuffer

	.elseif uMsg==WM_CLOSE
		invoke ReleaseDC, hWin, hDC
	    invoke DeleteObject, hBG_Brush
	    invoke DeleteObject, hFG_Brush
	    invoke DeleteObject, hFont
		invoke EndDialog, hWin, 0
	.else
		mov		eax, FALSE
		ret
	.endif
	mov		eax, TRUE
	ret

DlgProc endp

end start
